<template>
    <div class="component">
        <h3>Counter with message</h3>    
        <p>{{ msg }}</p>
        <p>count: {{ count }}</p>
        <button @click="clickHandler" @mouseover="increment2Handler">++1</button>
    </div>
</template>

<script>
export default {
    name: 'ComponentExample',
    props: {
        msg: {
            type: String,
            default: 'test'
        },
        initialValue: {
            type: Number,
            default: 0
        }
    },
    data() {
        return {
            count: this.initialValue
        }
    },
    methods: {
        clickHandler() {
            this.count++;
            this.$emit('update-value', this.count);
        },
        increment2Handler() {
            this.count += 2;
            this.$emit('update-value', this.count);
        }
    }
}
</script>

<style scoped>
.component {
    padding: 10px;
    background: #111;
    border: 1px solid #ccc;
    margin-top: 10px;
    margin-bottom: 10px;
}
</style>